---------------------------------------------------
-- package pack_Von_Neumann                      --
-- auteur : Matthias Colin                       --
-- date   : 17/02/2009                           --
--                                               --
-- dfinition des types communs aux diffrents   --
-- composants de la machine de Von Neumann       --
---------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;

package pack_Von_Neumann is

-- type des mots utiliss par la machine de Von Neumann
subtype t_mot is std_logic_vector(3 downto 0);

-- type des adresses utilises par la machine de Von Neumann
subtype t_address12 is std_logic_vector(11 downto 0);
	
-- type des oprations de l'ALU
type t_operation is (ADD, ADC, MULT, DIV, SUB, MODULO);


-- nombre de cycles d'attente pour un composant client de l'ALU
constant NB_CYCLES_ATTENTE_ALU : integer := 2;
	
end pack_Von_Neumann;



