-- CPU Machine de Von Neumann
-- Instructions  taille variable : 1  4 mots de 4 bits
-- 4 registres Rj, j=0  3
-- Registres PC/RI/MAR/MDR
--
-- auteur : Matthias Colin
-- version : 1.0 (4/06/2009)
--

library ieee;
use ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.all;

use vonneuman2010.pack_Von_Neumann.all;
use vonneuman2010.pack_cpu.all;

entity cpu is
port (
	-- control --
	clock : in std_logic; -- rising edge
	reset : in std_logic; -- active at lowlevel
	
	-- interface MEM --
	mdr_in : in t_mot;
	mdr_out : out t_mot;
	mar : out t_address12;
	rw_mem : out std_logic; -- 1 : read / 0 : write
	cs_mem : out std_logic; -- memory activation (low level)
	ready_mem : in boolean -- cache is ready to be used / to be read
	
	-- interface ALU --
	-- next time --
);
end cpu;

architecture cpu_arch of cpu is

-- les tats de la CPU : TODO
-- type t_etat_fetch_decode is (ETAT_XXX, ETAT_XXY, ... );

signal etat_fetch_decode : t_etat_fetch_decode;
	
-- les registres
type t_registres is array(0 to 3) of t_mot;
signal r : t_registres;

signal ri : std_logic_vector(15 downto 0);
signal pc : t_address12;

-- pour suivre le dcodage des instructions
signal opcode1 : t_opcode1word;
signal opcode2 : t_opcode2word;

begin

	process(clock, reset) is
	-- variables pour calculs intermdiaires
	variable v_opcode1 : t_opcode1word;
	variable v_opcode2 : t_opcode2word;
	variable num_registre : integer range 0 to 3; -- numro de registre
	variable j : integer;
	begin
		if reset='0' then
			-- on se place au dbut du programme  excuter
			pc <= (others => '0');
			ri <= (others => '0');
			for j in 0 to 3 loop
				r(j) <= (others => '0');
			end loop;
			-- init state
			-- TODO
			-- etat_fetch_decode <= 
		elsif clock'event and clock='1' then
			case etat_fetch_decode is
				-- TODO
				-- when ETAT_XXX => ...
					
			end case;	
		end if;
	end process;
	
end cpu_arch;



